/* *****************************************************************************
* ###############################################################################
* ##    Copyright (C) 2002 by Eric Gerbier
* ##    Bug reports to: gerbier@users.sourceforge.net
* ##    $Id$
* ##
* ##    This program is free software; you can redistribute it and/or modify
* ##    it under the terms of the GNU General Public License as published by
* ##    the Free Software Foundation; either version 2 of the License, or
* ##    (at your option) any later version.
* ##
* ##    This program is distributed in the hope that it will be useful,
* ##    but WITHOUT ANY WARRANTY; without even the implied warranty of
* ##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* ##    GNU General Public License for more details.
* ##
* ################################################################################
 ****************************************************************************** */
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>
# include <signal.h>
# include <string.h>
# include <sys/stat.h>
# include <sys/types.h>
# include <fam.h>

/* pour un arret propre */
int run = 1;

typedef void (*sighandler_t)(int);

void arret(int sig) {
	run = 0;
	printf("signal %d recu\n", sig);
}

/* **************************************** */
char* convert_code ( enum FAMCodes code) {
	switch (code) {
		case FAMChanged : return "FAMChanged";
				  break;
		case FAMDeleted : return "FAMDeleted";
				  break;
		case FAMStartExecuting : return "FAMStartExecuting";
				  break;
		case FAMStopExecuting : return "FAMStopExecuting";
				  break;
		case FAMCreated : return "FAMCreated";
				  break;
		case FAMMoved : return "FAMMoved";
				  break;
		case FAMAcknowledge : return "FAMAcknowledge";
				  break;
		case FAMExists : return "FAMExists";
				  break;
		case FAMEndExist : return "FAMEndExist";
				  break;
		default: return NULL;
			 break;
	}
	return NULL;
}
/* ***************** main ***************** */

int main(int argc, char* argv[]) {
	FAMConnection fc;
	FAMRequest fr;
	int iret;
	FAMEvent fe;
	char* name;
	int len;
	struct stat sttamp;

	if ( argc == 2) {
		len =  strlen(argv[1]) + 1;
		name = (char*) malloc( len * sizeof(char) );
		strcpy(name, argv[1]);

	} else {
		printf("donner un nom de fichier ou de repertoire a surveiller\n");
		return 0;
	}

	iret = FAMOpen(&fc);
	if ( iret != 0 ){
		printf("probleme ouverture connexion : %i\n", iret);
	}

	/* fichier ou repertoire ? */
	stat(name, &sttamp);
	if ( (sttamp.st_mode & S_IFMT ) == S_IFDIR ) {
		printf("surveillance du repertoire %s\n", name);
		iret = FAMMonitorDirectory(&fc, name, &fr, NULL);
		if ( iret != 0 ){
			printf("probleme FAMMonitorDirectory : %i\n", iret);
		}
	} else {
		printf("surveillance du fichier %s\n", name);
		iret = FAMMonitorFile(&fc, name, &fr, NULL);
		if ( iret != 0 ){
			printf("probleme FAMMonitorFile : %i\n", iret);
		}
	}

	signal (2, (sighandler_t) arret );
	signal (3, (sighandler_t) arret );
	signal (15, (sighandler_t) arret );

	while (run == 1) {
		if (FAMPending(&fc)) {
			FAMNextEvent(&fc, &fe);
			printf("fichier=%s code=%s\n",  fe.filename, convert_code(fe.code));
		} else {
			/* printf("attente\n"); */
			sleep(1);
		}
	}

	FAMClose(&fc);
	free(name);

	return 0;
}
